Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -14,8 +14,15 @@
 #               7) Rudiger Lange private communication (A700)
 #               8) Igal Milchtaich private communication
-#               9) Michael Reitinger private communication (DSC-TX7)
+#               9) Michael Reitinger private communication (DSC-TX7,RX100)
 #               10) http://www.klingebiel.com/tempest/hd/pmp.html
-#               11 Mike Battilana private communication
+#               11) Mike Battilana private communication
+#               13) http://www.mi-fo.de/forum/index.php?showtopic=33239
+#                   http://www.dyxum.com/dforum/the-alpha-shutter-count-tool_topic97489_page4.html
+#               14) Albert Shan private communication (A7M3)
+#               IB) Iliah Borg private communication (LibRaw)
 #               JD) Jens Duttke private communication
+#               JR) Jos Roost private communication
+#
+#               NC = Not Confirmed
 #------------------------------------------------------------------------------
 
@@ -23,16 +30,227 @@
 
 use strict;
-use vars qw($VERSION);
+use vars qw($VERSION %sonyLensTypes %sonyLensTypes2);
 use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
 use Image::ExifTool::Minolta;
 
-$VERSION = '1.50';
+$VERSION = '3.36';
 
 sub ProcessSRF($$$);
 sub ProcessSR2($$$);
+sub ProcessSonyPIC($$$);
+sub ProcessMoreInfo($$$);
+sub Process_rtmd($$$);
+sub Decipher($;$);
+sub ProcessEnciphered($$$);
+sub WriteEnciphered($$$);
 sub WriteSR2($$$);
-
-my %sonyLensTypes;  # filled in based on Minolta LensType's
+sub ConvLensSpec($);
+sub ConvInvLensSpec($);
+sub PrintLensSpec($);
+sub PrintInvLensSpec($;$$);
+
+# (%sonyLensTypes is filled in based on Minolta LensType's)
+
+# Sony E-mount lenses
+# (NOTE: these should be kept in sync with the 65535 entries in %minoltaLensTypes)
+%sonyLensTypes2 = (
+    Notes => 'Lens type numbers for Sony E-mount lenses used by NEX/ILCE models.',
+    0 => 'Unknown E-mount lens or other lens',
+    0.1   => 'Sigma 19mm F2.8 [EX] DN',
+    0.2   => 'Sigma 30mm F2.8 [EX] DN',
+    0.3   => 'Sigma 60mm F2.8 DN',
+    0.4   => 'Sony E 18-200mm F3.5-6.3 OSS LE',     # (firmware Ver.01)
+    0.5   => 'Tamron 18-200mm F3.5-6.3 Di III VC',  # (Model B011)
+    0.6   => 'Tokina FiRIN 20mm F2 FE AF',          # (firmware Ver.00) samples from Tokina, May 2018
+    0.7   => 'Tokina FiRIN 20mm F2 FE MF',          # samples from Tokina, 16-12-2016, DC-watch 01-02-2017
+    0.8   => 'Zeiss Touit 12mm F2.8',               # (firmware Ver.00)
+    0.9   => 'Zeiss Touit 32mm F1.8',               # (firmware Ver.00)
+   '0.10' => 'Zeiss Touit 50mm F2.8 Macro',         # (firmware Ver.00)
+   '0.11' => 'Zeiss Loxia 50mm F2',                 # (firmware Ver.01)
+   '0.12' => 'Zeiss Loxia 35mm F2',                 # (firmware Ver.01)
+    1 => 'Sony LA-EA1 or Sigma MC-11 Adapter', # MC-11 with not-supported lenses
+    2 => 'Sony LA-EA2 Adapter',
+    3 => 'Sony LA-EA3 Adapter',
+    6 => 'Sony LA-EA4 Adapter',
+    7 => 'Sony LA-EA5 Adapter', #JR
+    # 27 => Venus Optics Laowa 12mm f2.8 Zero-D or 105mm f2 (T3.2) Smooth Trans Focus (ref IB)
+    44 => 'Metabones Canon EF Smart Adapter', #JR
+    78 => 'Metabones Canon EF Smart Adapter Mark III or Other Adapter', #PH/JR (also Mark IV, Fotodiox and Viltrox)
+    184 => 'Metabones Canon EF Speed Booster Ultra', #JR ('Green' mode, LensMount reported as A-mount)
+    234 => 'Metabones Canon EF Smart Adapter Mark IV', #JR (LensMount reported as A-mount)
+    239 => 'Metabones Canon EF Speed Booster', #JR
+    24593 => 'LA-EA4r MonsterAdapter',
+                                                # Sony VX product code: (http://www.mi-fo.de/forum/index.php?s=7df1c8d3b1cd675f2abf4f4442e19cf2&showtopic=35035&view=findpost&p=303746)
+    32784 => 'Sony E 16mm F2.8',                # VX9100
+    32785 => 'Sony E 18-55mm F3.5-5.6 OSS',     # VX9101
+    32786 => 'Sony E 55-210mm F4.5-6.3 OSS',    # VX9102
+    32787 => 'Sony E 18-200mm F3.5-6.3 OSS',    # VX9103
+    32788 => 'Sony E 30mm F3.5 Macro',          # VX9104
+    32789 => 'Sony E 24mm F1.8 ZA or Samyang AF 50mm F1.4', # VX9105
+    32789.1 => 'Samyang AF 50mm F1.4',
+    32790 => 'Sony E 50mm F1.8 OSS or Samyang AF 14mm F2.8', # VX9106
+    32790.1 => 'Samyang AF 14mm F2.8',
+    32791 => 'Sony E 16-70mm F4 ZA OSS',        # VX9107
+    32792 => 'Sony E 10-18mm F4 OSS',           # VX9108
+    32793 => 'Sony E PZ 16-50mm F3.5-5.6 OSS',  # VX9109
+    32794 => 'Sony FE 35mm F2.8 ZA or Samyang Lens', # VX9110
+    32794.1 => 'Samyang AF 24mm F2.8', #JR
+    32794.2 => 'Samyang AF 35mm F2.8', #IB (also 51505)
+    32795 => 'Sony FE 24-70mm F4 ZA OSS',       # VX9111
+    32796 => 'Sony FE 85mm F1.8 or Viltrox PFU RBMH 85mm F1.8', #JR
+    32796.1 => 'Viltrox PFU RBMH 85mm F1.8', #JR (MF)
+    32797 => 'Sony E 18-200mm F3.5-6.3 OSS LE', # VX9113 (firmware Ver.02)
+    32798 => 'Sony E 20mm F2.8',                # VX9114
+    32799 => 'Sony E 35mm F1.8 OSS',            # VX9115
+    32800 => 'Sony E PZ 18-105mm F4 G OSS', #JR # VX9116
+    32801 => 'Sony FE 12-24mm F4 G', #JR
+    32802 => 'Sony FE 90mm F2.8 Macro G OSS',   # VX?
+    32803 => 'Sony E 18-50mm F4-5.6',
+    32804 => 'Sony FE 24mm F1.4 GM', #IB
+    32805 => 'Sony FE 24-105mm F4 G OSS', #IB   # VX9121
+
+    32807 => 'Sony E PZ 18-200mm F3.5-6.3 OSS', # VX9123
+    32808 => 'Sony FE 55mm F1.8 ZA',            # VX9124
+
+    32810 => 'Sony FE 70-200mm F4 G OSS', #JR   # VX9126
+    32811 => 'Sony FE 16-35mm F4 ZA OSS', #JR   # VX9127
+    32812 => 'Sony FE 50mm F2.8 Macro', #JR
+    32813 => 'Sony FE 28-70mm F3.5-5.6 OSS',    # VX9129
+    32814 => 'Sony FE 35mm F1.4 ZA',            # VX?
+    32815 => 'Sony FE 24-240mm F3.5-6.3 OSS',   # VX?
+    32816 => 'Sony FE 28mm F2', #JR             # VX?
+    32817 => 'Sony FE PZ 28-135mm F4 G OSS',#JR # VX?
+
+    32819 => 'Sony FE 100mm F2.8 STF GM OSS',   #JR (appears to use 33076 when switched to macro mode)
+    32820 => 'Sony E PZ 18-110mm F4 G OSS', #JR
+    32821 => 'Sony FE 24-70mm F2.8 GM', #JR/IB
+    32822 => 'Sony FE 50mm F1.4 ZA', #JR
+    32823 => 'Sony FE 85mm F1.4 GM or Samyang AF 85mm F1.4', #JR/IB
+    32823.1 => 'Samyang AF 85mm F1.4', #IB
+    32824 => 'Sony FE 50mm F1.8', #JR (Sony code 'SEL50F18F' with trailing "F" as compared to 'SEL50F18' for 32790)
+
+    32826 => 'Sony FE 21mm F2.8 (SEL28F20 + SEL075UWC)', #JR          # (+ Ultra-wide converter)
+    32827 => 'Sony FE 16mm F3.5 Fisheye (SEL28F20 + SEL057FEC)', #JR  # (+ Fisheye converter)
+    32828 => 'Sony FE 70-300mm F4.5-5.6 G OSS', #JR
+    32829 => 'Sony FE 100-400mm F4.5-5.6 GM OSS', #JR
+    32830 => 'Sony FE 70-200mm F2.8 GM OSS', #JR
+    32831 => 'Sony FE 16-35mm F2.8 GM', #JR
+    32848 => 'Sony FE 400mm F2.8 GM OSS', #IB
+    32849 => 'Sony E 18-135mm F3.5-5.6 OSS', #JR
+    32850 => 'Sony FE 135mm F1.8 GM', #IB
+    32851 => 'Sony FE 200-600mm F5.6-6.3 G OSS', #IB
+    32852 => 'Sony FE 600mm F4 GM OSS', #IB
+    32853 => 'Sony E 16-55mm F2.8 G', #IB/JR
+    32854 => 'Sony E 70-350mm F4.5-6.3 G OSS', #IB/JR
+    32858 => 'Sony FE 35mm F1.8', #JR/IB
+    32859 => 'Sony FE 20mm F1.8 G', #IB/JR
+    32860 => 'Sony FE 12-24mm F2.8 GM', #JR/IB
+    32864 => 'Sony FE 28-60mm F4-5.6', #JR
+    32865 => 'Sony FE 35mm F1.4 GM', #IB/JR
+
+  # (comment this out so LensID will report the LensModel, which is more useful)
+  # 32952 => 'Metabones Canon EF Speed Booster Ultra', #JR (corresponds to 184, but 'Advanced' mode, LensMount reported as E-mount)
+  # 33002 => 'Metabones Canon EF Smart Adapter with Ver.5x', #PH/JR (corresponds to 234, but LensMount reported as E-mount)
+
+    33072 => 'Sony FE 70-200mm F2.8 GM OSS + 1.4X Teleconverter', #JR
+    33073 => 'Sony FE 70-200mm F2.8 GM OSS + 2X Teleconverter', #JR
+    33076 => 'Sony FE 100mm F2.8 STF GM OSS (macro mode)', #JR (with macro switching ring set to "0.57m - 1.0m")
+    33077 => 'Sony FE 100-400mm F4.5-5.6 GM OSS + 1.4X Teleconverter', #JR
+    33078 => 'Sony FE 100-400mm F4.5-5.6 GM OSS + 2X Teleconverter', #JR
+    33079 => 'Sony FE 400mm F2.8 GM OSS + 1.4X Teleconverter', #IB
+    33080 => 'Sony FE 400mm F2.8 GM OSS + 2X Teleconverter', #JR
+    33081 => 'Sony FE 200-600mm F5.6-6.3 G OSS + 1.4X Teleconverter', #JR
+    33082 => 'Sony FE 200-600mm F5.6-6.3 G OSS + 2X Teleconverter', #JR
+    33083 => 'Sony FE 600mm F4 GM OSS + 1.4X Teleconverter', #JR (NC)
+    33084 => 'Sony FE 600mm F4 GM OSS + 2X Teleconverter', #JR
+
+    49201 => 'Zeiss Touit 12mm F2.8', #JR (lens firmware Ver.02)
+    49202 => 'Zeiss Touit 32mm F1.8', #JR (lens firmware Ver.02)
+    49203 => 'Zeiss Touit 50mm F2.8 Macro', #JR (lens firmware Ver.02)
+    49216 => 'Zeiss Batis 25mm F2', #JR
+    49217 => 'Zeiss Batis 85mm F1.8', #JR
+    49218 => 'Zeiss Batis 18mm F2.8', #IB
+    49219 => 'Zeiss Batis 135mm F2.8', #IB
+    49220 => 'Zeiss Batis 40mm F2 CF', #IB
+    49232 => 'Zeiss Loxia 50mm F2', #JR (lens firmware Ver.02)
+    49233 => 'Zeiss Loxia 35mm F2', #JR (lens firmware Ver.02)
+    49234 => 'Zeiss Loxia 21mm F2.8', #PH
+    49235 => 'Zeiss Loxia 85mm F2.4', #JR
+    49236 => 'Zeiss Loxia 25mm F2.4', #JR
+
+    49457 => 'Tamron 28-75mm F2.8 Di III RXD', #JR (Model A036)
+    49458 => 'Tamron 17-28mm F2.8 Di III RXD', #JR (Model A046)
+    49459 => 'Tamron 35mm F2.8 Di III OSD M1:2', #IB (Model F053)
+    49460 => 'Tamron 24mm F2.8 Di III OSD M1:2', #JR (Model F051)
+    49461 => 'Tamron 20mm F2.8 Di III OSD M1:2', #JR (Model F050)
+    49462 => 'Tamron 70-180mm F2.8 Di III VXD', #JR (Model A056)
+    49463 => 'Tamron 28-200mm F2.8-5.6 Di III RXD', #JR (Model A071)
+    49464 => 'Tamron 70-300mm F4.5-6.3 Di III RXD', #JR (Model A047)
+    49465 => 'Tamron 17-70mm F2.8 Di III-A VC RXD', #JR (Model B070)
+    49473 => 'Tokina atx-m 85mm F1.8 FE', #JR
+    49712 => 'Tokina FiRIN 20mm F2 FE AF',       # (firmware Ver.01)
+    49713 => 'Tokina FiRIN 100mm F2.8 FE MACRO', # (firmware Ver.01)
+
+    50480 => 'Sigma 30mm F1.4 DC DN | C', #IB/JR (016)
+    50481 => 'Sigma 50mm F1.4 DG HSM | A', #JR (014 + MC-11 or 018)
+    50482 => 'Sigma 18-300mm F3.5-6.3 DC MACRO OS HSM | C + MC-11', #JR (014)
+    50483 => 'Sigma 18-35mm F1.8 DC HSM | A + MC-11', #JR (013)
+    50484 => 'Sigma 24-35mm F2 DG HSM | A + MC-11', #JR (015)
+    50485 => 'Sigma 24mm F1.4 DG HSM | A + MC-11', #JR (015)
+    50486 => 'Sigma 150-600mm F5-6.3 DG OS HSM | C + MC-11', #JR (015)
+    50487 => 'Sigma 20mm F1.4 DG HSM | A + MC-11', #JR (015)
+    50488 => 'Sigma 35mm F1.4 DG HSM | A', #JR (012 + MC-11 or 018)
+    50489 => 'Sigma 150-600mm F5-6.3 DG OS HSM | S + MC-11', #JR (014)
+    50490 => 'Sigma 120-300mm F2.8 DG OS HSM | S + MC-11', #JR (013)
+    50492 => 'Sigma 24-105mm F4 DG OS HSM | A + MC-11', #JR (013)
+    50493 => 'Sigma 17-70mm F2.8-4 DC MACRO OS HSM | C + MC-11', #JR (013)
+    50495 => 'Sigma 50-100mm F1.8 DC HSM | A + MC-11', #JR (016)
+    50499 => 'Sigma 85mm F1.4 DG HSM | A', #JR (018)
+    50501 => 'Sigma 100-400mm F5-6.3 DG OS HSM | C + MC-11', #JR (017)
+    50503 => 'Sigma 16mm F1.4 DC DN | C', #JR (017)
+    50507 => 'Sigma 105mm F1.4 DG HSM | A', #IB (018)
+    50508 => 'Sigma 56mm F1.4 DC DN | C', #JR (018)
+    50512 => 'Sigma 70-200mm F2.8 DG OS HSM | S + MC-11', #IB (018) (JR added "+ MC-11")
+    50513 => 'Sigma 70mm F2.8 DG MACRO | A', #JR (018)
+    50514 => 'Sigma 45mm F2.8 DG DN | C', #IB/JR (019)
+    50515 => 'Sigma 35mm F1.2 DG DN | A', #IB/JR (019)
+    50516 => 'Sigma 14-24mm F2.8 DG DN | A', #IB/JR (019)
+    50517 => 'Sigma 24-70mm F2.8 DG DN | A', #JR (019)
+    50518 => 'Sigma 100-400mm F5-6.3 DG DN OS | C', #JR (020)
+    50521 => 'Sigma 85mm F1.4 DG DN | A', #JR (020)
+    50522 => 'Sigma 105mm F2.8 DG DN MACRO | A', #JR (020)
+    50523 => 'Sigma 65mm F2 DG DN | C', #IB (020)
+    50524 => 'Sigma 35mm F2 DG DN | C', #IB (020)
+    50525 => 'Sigma 24mm F3.5 DG DN | C', #JR (021)
+
+    50992 => 'Voigtlander SUPER WIDE-HELIAR 15mm F4.5 III', #JR
+    50993 => 'Voigtlander HELIAR-HYPER WIDE 10mm F5.6', #IB
+    50994 => 'Voigtlander ULTRA WIDE-HELIAR 12mm F5.6 III', #IB
+    50995 => 'Voigtlander MACRO APO-LANTHAR 65mm F2 Aspherical', #JR
+    50996 => 'Voigtlander NOKTON 40mm F1.2 Aspherical', #JR
+    50997 => 'Voigtlander NOKTON classic 35mm F1.4', #JR
+    50998 => 'Voigtlander MACRO APO-LANTHAR 110mm F2.5', #JR
+    50999 => 'Voigtlander COLOR-SKOPAR 21mm F3.5 Aspherical', #IB
+    51000 => 'Voigtlander NOKTON 50mm F1.2 Aspherical', #JR
+    51001 => 'Voigtlander NOKTON 21mm F1.4 Aspherical', #JR
+    51002 => 'Voigtlander APO-LANTHAR 50mm F2 Aspherical', #JR
+    51003 => 'Voigtlander NOKTON 35mm F1.2 Aspherical SE', #JR
+
+    # lenses listed in the Sigma MC-11 list, but not yet seen:
+    # 504xx => 'Sigma 18-200mm F3.5-6.3 DC MACRO OS HSM | C + MC-11', # (014)
+    # 504xx => 'Sigma 30mm F1.4 DC HSM | A + MC-11', # (013)
+
+    # Note: For Samyang lenses, the "FE" designation isn't written to
+    # EXIF:LensModel, so it isn't included in these strings either - JR/PH
+    51504 => 'Samyang AF 50mm F1.4', #IB
+    51505 => 'Samyang AF 14mm F2.8 or Samyang AF 35mm F2.8', #forum3833
+    51505.1 => 'Samyang AF 35mm F2.8', #PH (also 32794)
+    51507 => 'Samyang AF 35mm F1.4', #IB
+    51508 => 'Samyang AF 45mm F1.8',
+    51510 => 'Samyang AF 18mm F2.8 or Samyang AF 35mm F1.8', #JR
+    51510.1 => 'Samyang AF 35mm F1.8', #JR
+    51512 => 'Samyang AF 75mm F1.8', #IB/JR
+);
 
 # ExposureProgram values (ref PH, mainly decoded from A200)
@@ -45,11 +263,251 @@
     8 => 'Program Shift A', #7
     9 => 'Program Shift S', #7
+    16 => 'Portrait', # (A330)
+    17 => 'Sports', # (A330)
+    18 => 'Sunset', # (A330)
     19 => 'Night Portrait', # (A330)
-    18 => 'Sunset', # (A330)
-    17 => 'Sports', # (A330)
+    20 => 'Landscape', # (A330)
     21 => 'Macro', # (A330)
-    20 => 'Landscape', # (A330)
-    16 => 'Portrait', # (A330)
     35 => 'Auto No Flash', # (A330)
+);
+
+# ExposureProgram values in CameraSettings3 (ref JR)
+my %sonyExposureProgram2 = (            # A580 Mode Dial setting:
+     1 => 'Program AE',                 # P
+     2 => 'Aperture-priority AE',       # A
+     3 => 'Shutter speed priority AE',  # S
+     4 => 'Manual',                     # M
+     5 => 'Cont. Priority AE',          # (A35)
+    16 => 'Auto',                       # AUTO
+    17 => 'Auto (no flash)',            # "flash strike-out" symbol
+    18 => 'Auto+',                      #PH (A33)
+    49 => 'Portrait',                   # SCN
+    50 => 'Landscape',                  # SCN
+    51 => 'Macro',                      # SCN
+    52 => 'Sports',                     # SCN
+    53 => 'Sunset',                     # SCN
+    54 => 'Night view',                 # SCN
+    55 => 'Night view/portrait',        # SCN
+    56 => 'Handheld Night Shot',        # SCN (also called "Hand-held Twilight")
+    57 => '3D Sweep Panorama',          # "Panorama" symbol
+    64 => 'Auto 2',                     #PH (A33 AUTO)
+    65 => 'Auto 2 (no flash)',          #JR (NC, A35)
+    80 => 'Sweep Panorama',             # "Panorama" symbol
+    96 => 'Anti Motion Blur',           #PH (NEX-5)
+    # 128-138 are A35 picture effects (combined SCN/Picture effect mode dial position)
+    128 => 'Toy Camera',
+    129 => 'Pop Color',
+    130 => 'Posterization',
+    131 => 'Posterization B/W',
+    132 => 'Retro Photo',
+    133 => 'High-key',
+    134 => 'Partial Color Red',
+    135 => 'Partial Color Green',
+    136 => 'Partial Color Blue',
+    137 => 'Partial Color Yellow',
+    138 => 'High Contrast Monochrome',
+);
+
+# ExposureProgram values in Tags 2010 and 94xx (ref JR)
+my %sonyExposureProgram3 = (
+     0 => 'Program AE',
+     1 => 'Aperture-priority AE',
+     2 => 'Shutter speed priority AE',
+     3 => 'Manual',
+     4 => 'Auto',
+     5 => 'iAuto',
+     6 => 'Superior Auto',
+     7 => 'iAuto+',
+     8 => 'Portrait',
+     9 => 'Landscape',
+    10 => 'Twilight',
+    11 => 'Twilight Portrait',
+    12 => 'Sunset',
+    14 => 'Action (High speed)', #PH (RX100)
+    16 => 'Sports',
+    17 => 'Handheld Night Shot',
+    18 => 'Anti Motion Blur',
+    19 => 'High Sensitivity',
+    21 => 'Beach',
+    22 => 'Snow',
+    23 => 'Fireworks',
+    26 => 'Underwater',
+    27 => 'Gourmet',
+    28 => 'Pet',
+    29 => 'Macro',
+    30 => 'Backlight Correction HDR',
+    # 32 => 'Night ... ???', # seen for HDR-CX360E
+    33 => 'Sweep Panorama',
+    36 => 'Background Defocus',
+    37 => 'Soft Skin',
+    42 => '3D Image',
+    43 => 'Cont. Priority AE',
+    45 => 'Document',
+    46 => 'Party',
+);
+
+# WhiteBalanceSetting values (ref JR)
+my %whiteBalanceSetting = (
+    0x10 => 'Auto (-3)', #(NC)
+    0x11 => 'Auto (-2)', #(NC)
+    0x12 => 'Auto (-1)', #(NC)
+    0x13 => 'Auto (0)',
+    0x14 => 'Auto (+1)', #(NC)
+    0x15 => 'Auto (+2)', #(NC)
+    0x16 => 'Auto (+3)', #(NC)
+    0x20 => 'Daylight (-3)',
+    0x21 => 'Daylight (-2)', #(NC)
+    0x22 => 'Daylight (-1)', #(NC)
+    0x23 => 'Daylight (0)',
+    0x24 => 'Daylight (+1)',
+    0x25 => 'Daylight (+2)',
+    0x26 => 'Daylight (+3)',
+    0x30 => 'Shade (-3)', #(NC)
+    0x31 => 'Shade (-2)', #(NC)
+    0x32 => 'Shade (-1)', #(NC)
+    0x33 => 'Shade (0)',
+    0x34 => 'Shade (+1)', #(NC)
+    0x35 => 'Shade (+2)', #(NC)
+    0x36 => 'Shade (+3)',
+    0x40 => 'Cloudy (-3)', #(NC)
+    0x41 => 'Cloudy (-2)', #(NC)
+    0x42 => 'Cloudy (-1)', #(NC)
+    0x43 => 'Cloudy (0)',
+    0x44 => 'Cloudy (+1)', #(NC)
+    0x45 => 'Cloudy (+2)', #(NC)
+    0x46 => 'Cloudy (+3)', #(NC)
+    0x50 => 'Tungsten (-3)', #(NC)
+    0x51 => 'Tungsten (-2)', #(NC)
+    0x52 => 'Tungsten (-1)', #(NC)
+    0x53 => 'Tungsten (0)',
+    0x54 => 'Tungsten (+1)', #(NC)
+    0x55 => 'Tungsten (+2)', #(NC)
+    0x56 => 'Tungsten (+3)', #(NC)
+    0x60 => 'Fluorescent (-3)', #(NC)
+    0x61 => 'Fluorescent (-2)', #(NC)
+    0x62 => 'Fluorescent (-1)', #(NC)
+    0x63 => 'Fluorescent (0)',
+    0x64 => 'Fluorescent (+1)', #(NC)
+    0x65 => 'Fluorescent (+2)', #(NC)
+    0x66 => 'Fluorescent (+3)', #(NC)
+    0x70 => 'Flash (-3)', #(NC)
+    0x71 => 'Flash (-2)', #(NC)
+    0x72 => 'Flash (-1)', #(NC)
+    0x73 => 'Flash (0)',
+    0x74 => 'Flash (+1)', #(NC)
+    0x75 => 'Flash (+2)', #(NC)
+    0x76 => 'Flash (+3)', #(NC)
+    0xa3 => 'Custom',
+    0xf3 => 'Color Temperature/Color Filter',
+);
+
+# AF points for cameras with 15-point AF (ref JR)
+my %afPoint15 = (
+    0 => 'Upper-left',
+    1 => 'Left',
+    2 => 'Lower-left',
+    3 => 'Far Left',
+    4 => 'Top (horizontal)',
+    5 => 'Near Right',
+    6 => 'Center (horizontal)',
+    7 => 'Near Left',
+    8 => 'Bottom (horizontal)',
+    9 => 'Top (vertical)',
+    10 => 'Center (vertical)',
+    11 => 'Bottom (vertical)',
+    12 => 'Far Right',
+    13 => 'Upper-right',
+    14 => 'Right',
+    15 => 'Lower-right',
+    16 => 'Upper-middle',
+    17 => 'Lower-middle',
+);
+
+# AF points for cameras with 19-point AF (ref PH)
+# (verified for A77 firmware 1.07)
+my %afPoint19 = (
+    0 => 'Upper Far Left',
+    1 => 'Upper-left (horizontal)',
+    2 => 'Far Left (horizontal)',
+    3 => 'Left (horizontal)',
+    4 => 'Lower Far Left',
+    5 => 'Lower-left (horizontal)',
+    6 => 'Upper-left (vertical)',
+    7 => 'Left (vertical)',
+    8 => 'Lower-left (vertical)',
+    9 => 'Far Left (vertical)',
+    10 => 'Top (horizontal)',
+    11 => 'Near Right',
+    12 => 'Center (horizontal)',
+    13 => 'Near Left',
+    14 => 'Bottom (horizontal)',
+    15 => 'Top (vertical)',
+    16 => 'Upper-middle',
+    17 => 'Center (vertical)',
+    18 => 'Lower-middle',
+    19 => 'Bottom (vertical)',
+    20 => 'Upper Far Right',
+    21 => 'Upper-right (horizontal)',
+    22 => 'Far Right (horizontal)',
+    23 => 'Right (horizontal)',
+    24 => 'Lower Far Right',
+    25 => 'Lower-right (horizontal)',
+    26 => 'Far Right (vertical)',
+    27 => 'Upper-right (vertical)',
+    28 => 'Right (vertical)',
+    29 => 'Lower-right (vertical)',
+);
+
+# 79 AF point layout and indices for ILCA-68/77M2, numbered 0-78 for direct look-up from BITMASK in 0x2020,
+# E6 = Center (ref JR)
+my %afPoints79 = (
+                                             0=>'A5',  1=>'A6',  2=>'A7',
+               3=>'B2',  4=>'B3',  5=>'B4',  6=>'B5',  7=>'B6',  8=>'B7',  9=>'B8', 10=>'B9', 11=>'B10',
+    12=>'C1', 13=>'C2', 14=>'C3', 15=>'C4', 16=>'C5', 17=>'C6', 18=>'C7', 19=>'C8', 20=>'C9', 21=>'C10', 22=>'C11',
+    23=>'D1', 24=>'D2', 25=>'D3', 26=>'D4', 27=>'D5', 28=>'D6', 29=>'D7', 30=>'D8', 31=>'D9', 32=>'D10', 33=>'D11',
+    34=>'E1', 35=>'E2', 36=>'E3', 37=>'E4', 38=>'E5', 39=>'E6', 40=>'E7', 41=>'E8', 42=>'E9', 43=>'E10', 44=>'E11',
+    45=>'F1', 46=>'F2', 47=>'F3', 48=>'F4', 49=>'F5', 50=>'F6', 51=>'F7', 52=>'F8', 53=>'F9', 54=>'F10', 55=>'F11',
+    56=>'G1', 57=>'G2', 58=>'G3', 59=>'G4', 60=>'G5', 61=>'G6', 62=>'G7', 63=>'G8', 64=>'G9', 65=>'G10', 66=>'G11',
+              67=>'H2', 68=>'H3', 69=>'H4', 70=>'H5', 71=>'H6', 72=>'H7', 73=>'H8', 74=>'H9', 75=>'H10',
+                                            76=>'I5', 77=>'I6', 78=>'I7',
+);
+
+# AFPoint and AFStatus tags in AFInfo(Tag940e) use numbers 0 to 94 for the 79 positions + 15 cross + 1 F2.8
+my %afPoints79_940e = (
+                                            59=>'A5', 50=>'A6', 41=>'A7',
+              14=>'B2',  7=>'B3',  0=>'B4', 60=>'B5', 51=>'B6', 42=>'B7', 87=>'B8', 80=>'B9', 73=>'B10',
+    21=>'C1', 15=>'C2',  8=>'C3',  1=>'C4', 61=>'C5', 52=>'C6', 43=>'C7', 88=>'C8', 81=>'C9', 74=>'C10', 68=>'C11',
+    22=>'D1', 16=>'D2',  9=>'D3',  2=>'D4', 62=>'D5', 53=>'D6', 44=>'D7', 89=>'D8', 82=>'D9', 75=>'D10', 69=>'D11',
+    23=>'E1', 17=>'E2', 10=>'E3',  3=>'E4', 63=>'E5', 54=>'E6 Center', 45=>'E7', 90=>'E8', 83=>'E9', 76=>'E10', 70=>'E11',
+    24=>'F1', 18=>'F2', 11=>'F3',  4=>'F4', 64=>'F5', 55=>'F6', 46=>'F7', 91=>'F8', 84=>'F9', 77=>'F10', 71=>'F11',
+    25=>'G1', 19=>'G2', 12=>'G3',  5=>'G4', 65=>'G5', 56=>'G6', 47=>'G7', 92=>'G8', 85=>'G9', 78=>'G10', 72=>'G11',
+              20=>'H2', 13=>'H3',  6=>'H4', 66=>'H5', 57=>'H6', 48=>'H7', 93=>'H8', 86=>'H9', 79=>'H10',
+                                            67=>'I5', 58=>'I6', 49=>'I7',
+
+                                   28=>'A5 Vertical', 27=>'A6 Vertical', 26=>'A7 Vertical',
+                                   31=>'C5 Vertical', 30=>'C6 Vertical', 29=>'C7 Vertical',
+                                   34=>'E5 Vertical', 33=>'E6 Center Vertical', 32=>'E7 Vertical',
+                                   37=>'G5 Vertical', 36=>'G6 Vertical', 35=>'G7 Vertical',
+                                   40=>'I5 Vertical', 39=>'I6 Vertical', 38=>'I7 Vertical',
+
+                                                      94=>'E6 Center F2.8',
+);
+
+# ILCA-99M2 has dedicated 79 point Phase Detection AF sensor with similar layout as ILCA-68 and ILCA-77M2.
+# ILCA-99M2 has also 399 Focal Plane Phase-Detection AF Points in 19 rows of 21 points, same as ILCE-7RM2.
+# Of these 399 points, 323 points are selectable: 19 rows of 17 points (2 left-most and right-most columns not selectable).
+# The 79 Focal Plane points that overlap with the 79 points of the dedicated sensor provide for Hybrid Phase AF Points.
+# Tag 0x201e gives value 162 for the Center AF point, and 162 is exactly the center of 323 points...
+# The below table lists the selectable AF points that correspond to the 79 points of the dedicated sensor. (ref JR)
+my %afPoints99M2 = (
+                                                                           93=>'A5 (93)',   94=>'A6 (94)',   95=>'A7 (95)',
+                    106=>'B2 (106)', 107=>'B3 (107)', 108=>'B4 (108)',    110=>'B5 (110)', 111=>'B6 (111)', 112=>'B7 (112)',    114=>'B8 (114)', 115=>'B9 (115)', 116=>'B10 (116)',
+   122=>'C1 (122)', 123=>'C2 (123)', 124=>'C3 (124)', 125=>'C4 (125)',    127=>'C5 (127)', 128=>'C6 (128)', 129=>'C7 (129)',    131=>'C8 (131)', 132=>'C9 (132)', 133=>'C10 (133)', 134=>'C11 (134)',
+   139=>'D1 (139)', 140=>'D2 (140)', 141=>'D3 (141)', 142=>'D4 (142)',    144=>'D5 (144)', 145=>'D6 (145)', 146=>'D7 (146)',    148=>'D8 (148)', 149=>'D9 (149)', 150=>'D10 (150)', 151=>'D11 (151)',
+   156=>'E1 (156)', 157=>'E2 (157)', 158=>'E3 (158)', 159=>'E4 (159)',    161=>'E5 (161)', 162=>'E6 (162)', 163=>'E7 (163)',    165=>'E8 (165)', 166=>'E9 (166)', 167=>'E10 (167)', 168=>'E11 (168)',
+   173=>'F1 (173)', 174=>'F2 (174)', 175=>'F3 (175)', 176=>'F4 (176)',    178=>'F5 (178)', 179=>'F6 (179)', 180=>'F7 (180)',    182=>'F8 (182)', 183=>'F9 (183)', 184=>'F10 (184)', 185=>'F11 (185)',
+   190=>'G1 (190)', 191=>'G2 (191)', 192=>'G3 (192)', 193=>'G4 (193)',    195=>'G5 (195)', 196=>'G6 (196)', 197=>'G7 (197)',    199=>'G8 (199)', 200=>'G9 (200)', 201=>'G10 (201)', 202=>'G11 (202)',
+                    208=>'H2 (208)', 209=>'H3 (209)', 210=>'H4 (210)',    212=>'H5 (212)', 213=>'H6 (213)', 214=>'H7 (214)',    216=>'H8 (216)', 217=>'H9 (217)', 218=>'H10 (218)',
+                                                                          229=>'I5 (229)', 230=>'I6 (230)', 231=>'I7 (231)',
 );
 
@@ -62,8 +520,100 @@
 );
 
+# tagInfo attributes for unknown cipher block tags
+my %unknownCipherData = (
+    Unknown => 1,   # require Unknown option
+    Hidden => 1,    # doesn't appear in Tag Name documentation
+    RawConv => sub { Decipher(\$_[0]); return $_[0] },
+    ValueConv => 'PrintHex($val)',                      # print as hex
+    PrintConv => 'length($val) > 65 ? substr($val,0,60) . "[...]" : $val',  # limit length
+);
+
+my %meterInfo1 = (
+    Format => 'int32u[27]',
+    PrintConv => 'sprintf("%19d %4d %6d" . " %3d %4d %6d" x 8, split(" ",$val))',
+    PrintConvInv => '$val',
+);
+my %meterInfo2 = (
+    Format => 'int32u[33]',
+    PrintConv => 'sprintf("%3d %4d %6d" . " %3d %4d %6d" x 10, split(" ",$val))',
+    PrintConvInv => '$val',
+);
+my %meterInfo1b = (
+    Format => 'undef[90]',
+    ValueConv => \&ConvMeter1,
+    PrintConv => 'sprintf("%19d %4d %6d" . " %3d %4d %6d" x 8, split(" ",$val))',
+);
+my %meterInfo2b = (
+    Format => 'undef[110]',
+    ValueConv => \&ConvMeter2,
+    PrintConv => 'sprintf("%3d %4d %6d" . " %3d %4d %6d" x 10, split(" ",$val))',
+);
+
+my %hidUnk = ( Hidden => 1, Unknown => 1 );
+
+# Sony maker notes tags (some elements in common with %Image::ExifTool::Minolta::Main)
 %Image::ExifTool::Sony::Main = (
     WRITE_PROC => \&Image::ExifTool::Exif::WriteExif,
     CHECK_PROC => \&Image::ExifTool::Exif::CheckExif,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        The following information has been decoded from the MakerNotes of Sony
+        cameras.  Some of these tags have been inherited from the Minolta
+        MakerNotes.
+    },
+    0x0010 => [ #PH
+        # appears to contain mostly AF related information;
+        # for SLT-A77V and newer, similar info is found in 0x940e AFInfo" (ref JR)
+        {
+            Name => 'CameraInfo',
+            # count: A700=368, A850/A900=5478
+            Condition => '$count == 368 or $count == 5478',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::CameraInfo',
+                ByteOrder => 'BigEndian',
+            },
+        },{
+            Name => 'CameraInfo2',
+            # count: A200/A300/A350=5506, A230/A290/A330/A380/A390=6118
+            Condition => '$count == 5506 or $count == 6118',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::CameraInfo2',
+                ByteOrder => 'LittleEndian',
+            },
+        },{
+            Name => 'CameraInfo3',
+            # count: A33/A35/A55V/A450/A500/A550/A560/A580/NEX3/5/5C/C3/VG10E=15360
+            Condition => '$count == 15360',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::CameraInfo3',
+                ByteOrder => 'LittleEndian',
+            },
+        },{
+            Name => 'CameraInfoUnknown',
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::CameraInfoUnknown' },
+        },
+    ],
+    # 0x0018 - starts with "GYRO" for sweep panorama images (ref JR)
+    #        - contains ImageStabilization information for Minolta
+    0x0020 => [
+        # similar to WBInfoA100 in Minolta.pm.
+        # appears to contain various types of information, as in MoreInfo. (ref JR)
+        {
+            Name => 'FocusInfo', #PH
+            # count: A200/A230/A290/A300/A330/A350/A380/A390==19154, A700/A850/A900=19148
+            Condition => '$count == 19154 or $count == 19148',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::FocusInfo',
+                ByteOrder => 'LittleEndian',
+            },
+        },{
+            Name => 'MoreInfo', #JR
+            # count: A450/A500/A550/A560/A580/A33/A35/A55/NEX-3/5/C3/VG10E==20480
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::MoreInfo',
+                ByteOrder => 'LittleEndian',
+            },
+        },
+    ],
     0x0102 => { #5/JD
         Name => 'Quality',
@@ -79,4 +629,5 @@
             7 => 'Compressed RAW',
             8 => 'Compressed RAW + JPEG',
+            0xffffffff => 'n/a', #PH (SLT-A57 panorama)
         },
     },
@@ -86,15 +637,9 @@
         Writable => 'rational64s',
     },
-    0x0105 => { #5/JD
+    0x0105 => { #5/JD (models since mid-2014, ILCA-77M2, ILCE-7M2/7RM2/7SM2, do not report this tag anymore, ref JR)
         Name => 'Teleconverter',
         Writable => 'int32u',
         PrintHex => 1,
-        PrintConv => {
-            0 => 'None',
-            72 => 'Minolta AF 2x APO (D)',
-            80 => 'Minolta AF 2x APO II',
-            136 => 'Minolta AF 1.4x APO (D)',
-            144 => 'Minolta AF 1.4x APO II',
-        },
+        PrintConv => \%Image::ExifTool::Minolta::minoltaTeleconverters,
     },
     0x0112 => { #JD
@@ -106,19 +651,27 @@
         {
             Name => 'CameraSettings',
-            Condition => '$$self{Model} =~ /DSLR-A(200|230|300|350|700|850|900)\b/',
+            # count: A200/A300/A350/A700=280, A850/A900=364
+            Condition => '$count == 280 or $count == 364',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Sony::CameraSettings',
                 ByteOrder => 'BigEndian',
             },
-        },
-        {
+        },{
             Name => 'CameraSettings2',
-            Condition => '$$self{Model} =~ /DSLR-A(330|380)\b/',
+            # count: A230/A290/A330/A380/A390=332
+            Condition => '$count == 332',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Sony::CameraSettings2',
                 ByteOrder => 'BigEndian',
             },
-        },
-        {
+        },{
+            Name => 'CameraSettings3',
+            # count: A560/A580/A33/A35/A55/NEX3/5/5C/C3/VG10E=1536, A450/A500/A550=2048
+            Condition => '$count == 1536 || $count == 2048',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::CameraSettings3',
+                ByteOrder => 'LittleEndian',
+            },
+        },{
             Name => 'CameraSettingsUnknown',
             SubDirectory => {
@@ -131,4 +684,5 @@
         Name => 'WhiteBalance',
         Writable => 'int32u',
+        Priority => 2, # (more reliable for the RX100)
         PrintHex => 1,
         PrintConv => {
